#!/usr/bin/env python3
# *-* coding:utf-8 *-*

if __name__ == "__main__":
    pass
class BinTree:
    def __init__(self):
        self.root = None
    def insert(self, value):
        if( self.root is None):
            self.root = BinTreeNode(value)
        else:
            self.root.insert(value)
    def search(self, value):
        if(self.root == value):
            return self
        elif (self.root.left != None or self.root.right != None):
            return self.root.search(value)
        return None

class BinTreeNode:
    def __init__(self, value):
        self.value = value
        self.left = None
        self.right = None
    def insert(self, value):
        if(value > self.value):
            self.right = BinTreeNode(value)
        elif (value < self.value):
            self.left = BinTreeNode(value)
    def search(self, value):
        if(value == self.right.value):
            return self.right
        elif(value == self.left.value):
            return self.left
        if (value > self.value):
            self.right.search(value)
        elif( value < self.value):
            self.left.search(value)
        


if __name__ == "__main__":
    values = [7, 3, 9, 2, 4, 8, 11]
    tree = BinTree()
    for value in values:
        tree.insert(value)
    for value in values:
        node = tree.search(value)
