from django.shortcuts import render

from .models import *

# Create your views here.
def index(request):
    context = {
        'profs': len(Professor.objects.all()),
        'students': len(Student.objects.all()),
        'exams': len(Exam.objects.all())
    }
    return render(request, 'university/index.html', context)

def professors(request):
    context = {
        'profs': Professor.objects.all()
    }
    return render(request, 'university/professors.html', context)

def students(request):
    context = {
        'students': Student.objects.all()
    }
    return render(request, 'university/students.html', context)
    
def exams(request):
    context = {
        'exams': Exam.objects.all()
    }
    return render(request, 'university/exams.html', context)
